<?PHP
/*
original file name   : myfriendicons.lib.php
begin                : February 1 2005
copyright            : (C) 2001 Y!MP Group
email                : support@yahooplus.fr.st

This program is free software; you can redistribute it and/or modify  	
it under the terms of the GNU General Public License as published by  
the Free Software Foundation; either version 2 of the License, or	    	
(at your option) any later version.

AUTHORS:
Olivier D. alias ze kat :	oliezekat@yahoo.fr	since February 1 2005

GLOBAL VARS:
$mYFriendIcons[][]			:	Array (2x) which store settings (paths, URLs, templates, strings, etc)

FUNCTIONS AVAILABLES:
mYFI_SetPaths()					:
mYFI_SetTitles()				:
mYFI_SetTemplates()				:
mYFI_SetPopUpScript()			:
mYFI_SetThumbailsSizes()		:
mYFI_SetPicturesURLs()			:
mYFI_Print() 					:	print HTML source-code from templates and settings of $mYFriendIcons
mYFI_GetInfos()					:
mYFI_File_NameToDisplay()		:
*/

//Tableau avec les noms de fichiers-images  ignorer
$MYFI_FILES_TO_IGNORE = array('download-icon.gif'
								,'friend-icons-file-icon.gif'
								,'header-bg-left.gif'
								,'header-bg-right.gif'
								,'logo-yahoo.gif'
								,'preview-icon.gif'
								,'repeat-dot-background.gif');
//URLs des copyrights
define('_MYFI_YMESSENGERPLUS_URL','http://pagesperso.laposte.net/yahooplus/');

function mYFI_SetPaths($LocalPath='./',$AbsoluteURL='',$SubFolder='')
	{
	//Configuration de mYFriendIcons
	global $mYFriendIcons;
	
	if ($AbsoluteURL == '')
		{
		$AbsoluteURLInfo = pathinfo('http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF']);
		$AbsoluteURL = $AbsoluteURLInfo['dirname'];
		}
	
	if ($SubFolder)
		{
		//Where are icon's files ?
		$mYFriendIcons['Source']['Path'] 				= $LocalPath."/".$SubFolder;
		$mYFriendIcons['Source']['URL'] 				= $AbsoluteURL."/".$SubFolder;
		}
	else
		{
		//Where are icon's files ?
		$mYFriendIcons['Source']['Path'] 				= $LocalPath;
		$mYFriendIcons['Source']['URL'] 				= $AbsoluteURL;
		}
		
	mYFI_SetPicturesURLs($AbsoluteURL);
	
	if (substr($mYFriendIcons['Source']['URL'], -1) == '/')
		{
		$mYFriendIcons['Preview']['URL'] 				= $mYFriendIcons['Source']['URL'];
		}
	else
		{
		$mYFriendIcons['Preview']['URL'] 				= $mYFriendIcons['Source']['URL'].'/';
		}
	
	$mYFriendIcons['Thumbails']['Path'] 				= $mYFriendIcons['Source']['Path'];
	$mYFriendIcons['Thumbails']['URL'] 					= $mYFriendIcons['Source']['URL'];
	}

function mYFI_SetTitles($LanguageCode='en')
	{
	//Configuration de mYFriendIcons
	global $mYFriendIcons;
	
	if ($LanguageCode == 'fr')
		{
		$mYFriendIcons['Language']					 	= 'fr';
		
		$mYFriendIcons['Titles']['ClickToShowPreview'] 	= "Cliquez pour voir un aperu du portrait-icone";
		$mYFriendIcons['Titles']['ClickToYahoo']		= "Cliquez pour installer automatiquement ce portrait-icone dans Yahoo! Messenger";
		$mYFriendIcons['Titles']['ClickToDownload']		= "Cliquez pour tlcharger ce portrait-icone";
		}
	else
		{
		$mYFriendIcons['Language']					 	= 'en';
		
		$mYFriendIcons['Titles']['ClickToShowPreview'] 	= "Click to see preview";
		$mYFriendIcons['Titles']['ClickToYahoo']		= "Click to add this friend-icon into Yahoo! Messenger";
		$mYFriendIcons['Titles']['ClickToDownload']		= "Click to download this friend-icon";
		}
	}
	
//Set templates for HTML output
function mYFI_SetTemplates($ModelCode='TABLE')
	{
	//Configuration de mYFriendIcons
	global $mYFriendIcons;
	
	if ($ModelCode == 'LIST')
		{
		$mYFriendIcons['Templates']['Begin'] 			= "<ul style=\"list-style-type: none\">\n";
		$mYFriendIcons['Templates']['ItemBegin'] 		= "<li>\n";
		$mYFriendIcons['Templates']['ThumbailOnClick']	= $mYFriendIcons['Preview']['JavaScript']."('%window-name%','".$mYFriendIcons['Preview']['Width']."','".$mYFriendIcons['Preview']['Height']."');";
		$mYFriendIcons['Templates']['Preview'] 			= "<a href=\"%preview-url%\" target=\"%window-name%\" onclick=\"%thumbail-on-click%\"><img src=\"".$mYFriendIcons['Pictures']['PreviewIcon']."\" align=\"absmiddle\" border=\"0\" title=\"".$mYFriendIcons['Titles']['ClickToShowPreview']."\" vspace=\"1\" /></a>\n";
		$mYFriendIcons['Templates']['ItemBody'] 		= "<a href=\"%download-url%\" title=\"%download-title%\">%icon-tpl%</a>\n <sup>%preview-tpl%</sup>\n <a href=\"%download-url%\" title=\"%download-title%\">%display-name%</a> <a href=\"%yahoo-url%\"><img src=\"".$mYFriendIcons['Pictures']['YahooIcon']."\" title=\"".$mYFriendIcons['Titles']['ClickToYahoo']."\" border=\"0\" align=\"absmiddle\" /></a>\n";
		$mYFriendIcons['Templates']['ItemEnd'] 			= "</li>\n";
		$mYFriendIcons['Templates']['NewItemsGroup'] 	= "";
		$mYFriendIcons['Templates']['End'] 				= "</ul>\n";
		
		$mYFriendIcons['Settings']['ItemsByGroup'] = 0;
		}
	else if ($ModelCode == 'TABLE-LISTS')
		{
		$mYFriendIcons['Templates']['Begin'] 			= "<table width=\"95%\">\n<tr>\n<td align=\"left\" valign=\"top\">\n<ul style=\"list-style-type: none\">\n";
		$mYFriendIcons['Templates']['ItemBegin'] 		= "<li>\n";
		$mYFriendIcons['Templates']['ThumbailOnClick']	= $mYFriendIcons['Preview']['JavaScript']."('%window-name%','".$mYFriendIcons['Preview']['Width']."','".$mYFriendIcons['Preview']['Height']."');";
		$mYFriendIcons['Templates']['Preview'] 			= "<a href=\"%preview-url%\" target=\"%window-name%\" onclick=\"%thumbail-on-click%\"><img src=\"".$mYFriendIcons['Pictures']['PreviewIcon']."\" align=\"absmiddle\" border=\"0\" title=\"".$mYFriendIcons['Titles']['ClickToShowPreview']."\" vspace=\"1\" /></a>\n";
		$mYFriendIcons['Templates']['ItemBody'] 		= "<a href=\"%download-url%\" title=\"%download-title%\">%icon-tpl%</a>\n <sup>%preview-tpl%</sup>\n <a href=\"%download-url%\" title=\"%download-title%\">%display-name%</a> <a href=\"%yahoo-url%\"><img src=\"".$mYFriendIcons['Pictures']['YahooIcon']."\" title=\"".$mYFriendIcons['Titles']['ClickToYahoo']."\" border=\"0\" align=\"absmiddle\" /></a>\n";
		$mYFriendIcons['Templates']['ItemEnd'] 			= "</li>\n";
		$mYFriendIcons['Templates']['NewItemsGroup'] 	= "</ul></td>\n<td align=\"left\" valign=\"top\">\n<ul style=\"list-style-type: none\">\n";
		$mYFriendIcons['Templates']['End'] 				= "</ul>\n</td>\n</tr>\n</table>";
		}
	else
		{
		$mYFriendIcons['Templates']['Begin'] 			= "<center><table width=\"95%\">\n<tr>\n";
		$mYFriendIcons['Templates']['ItemBegin'] 		= "<td align=\"center\" valign=\"top\">\n";
		if ($mYFriendIcons['Preview']['JavaScript'])
			{
			$mYFriendIcons['Templates']['ThumbailOnClick']	= $mYFriendIcons['Preview']['JavaScript']."('%window-name%','".$mYFriendIcons['Preview']['Width']."','".$mYFriendIcons['Preview']['Height']."');";
			$mYFriendIcons['Templates']['Preview'] 			= "<a href=\"%preview-url%\" target=\"%window-name%\" onclick=\"%thumbail-on-click%\"><img width=\"".$mYFriendIcons['Thumbails']['Width']."\" height=\"".$mYFriendIcons['Thumbails']['Height']."\" src=\"%thumbail-url%\" border=\"0\" title=\"".$mYFriendIcons['Titles']['ClickToShowPreview']."\" align=\"texttop\" vspace=\"1\" class=\"myfiThumbail\" /></a>\n";
			}
		else
			{
			$mYFriendIcons['Templates']['ThumbailOnClick']	= '';
			$mYFriendIcons['Templates']['Preview'] 			= "<img width=\"".$mYFriendIcons['Thumbails']['Width']."\" height=\"".$mYFriendIcons['Thumbails']['Height']."\" src=\"%thumbail-url%\" border=\"0\" align=\"texttop\" vspace=\"1\" class=\"myfiThumbail\" />\n";
			}
		$mYFriendIcons['Templates']['ItemBody'] 		= "%preview-tpl%<br />\n<a href=\"%download-url%\" target=\"_blank\" title=\"%download-title%\" class=\"myfiNameLink\">%display-name%</a>\n <a href=\"%yahoo-url%\"><img src=\"".$mYFriendIcons['Pictures']['YahooIcon']."\" title=\"".$mYFriendIcons['Titles']['ClickToYahoo']."\" border=\"0\" align=\"absmiddle\" /></a>\n";
		$mYFriendIcons['Templates']['ItemEnd'] 			= "</td>\n";
		$mYFriendIcons['Templates']['NewItemsGroup'] 	= "</tr>\n<tr>\n";
		$mYFriendIcons['Templates']['End'] 				= "</tr>\n</table></center>\n";
		}
	}
	
function mYFI_SetPopUpScript($Width=96,$Height=0)
	{
	//Configuration de mYFriendIcons
	global $mYFriendIcons;
	
	if ($Height == 0) { $Height = $Width; };
	
	$mYFriendIcons['Preview']['JavaScript'] 		= "mYFIPopUp";
	$mYFriendIcons['Preview']['Width'] 				= $Width;
	$mYFriendIcons['Preview']['Height'] 			= $Height;

	echo("<script type=\"text/javascript\" language=\"JavaScript\">");
	echo("function mYFIPopUp(WindowName,WindowWidth,WindowHeight)");
	echo("{");
	echo("mYFIPopUpWindow=open('',WindowName,\"hotkeys=no,personalbar=no,toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,dependent=yes,width=".($Width + 20).",height=".($Height + 30)."\");");
	echo("}");
	echo("</script>");
	}

function mYFI_SetThumbailsSizes($Width=96,$Height=0)
	{
	//Configuration de mYFriendIcons
	global $mYFriendIcons;
	
	$mYFriendIcons['Thumbails']['Width'] 			= $Width;
	if ($Height == 0)
		{
		$mYFriendIcons['Thumbails']['Height'] 		= $Width;
		}
	else
		{
		$mYFriendIcons['Thumbails']['Height'] 		= $Height;
		}
	}
	
function mYFI_SetPicturesURLs($URL='./')
	{
	//Configuration de mYFriendIcons
	global $mYFriendIcons;
	
	$mYFriendIcons['Pictures']['URL'] 				= $URL;
	if (substr($mYFriendIcons['Pictures']['URL'], -1) == '/')
		{
		$mYFriendIcons['Pictures']['PreviewIcon'] 		= $mYFriendIcons['Pictures']['URL']."preview-icon.gif";
		$mYFriendIcons['Pictures']['YahooIcon'] 		= $mYFriendIcons['Pictures']['URL']."logo-yahoo.gif";
		}
	else
		{
		$mYFriendIcons['Pictures']['PreviewIcon'] 		= $mYFriendIcons['Pictures']['URL']."/preview-icon.gif";
		$mYFriendIcons['Pictures']['YahooIcon'] 		= $mYFriendIcons['Pictures']['URL']."/logo-yahoo.gif";
		}
	}

function mYFI_Print()
	{
	//Configuration de mYFriendIcons
	global $mYFriendIcons;
	global $MYFI_FILES_TO_IGNORE;
	
	//Download URL while users click... mYFriendIcons add filename to download at end.
	if (substr($mYFriendIcons['Source']['URL'], -1) == '/')
		{
		$mYFriendIcons['Settings']['DownloadURL'] 		= $mYFriendIcons['Source']['URL'];
		}
	else
		{
		$mYFriendIcons['Settings']['DownloadURL'] 		= $mYFriendIcons['Source']['URL']."/";
		}
	$mYFriendIcons['Settings']['YahooURL'] 			= "ymsgr:displayimage?pic=".$mYFriendIcons['Source']['URL']."/";

	//Debut affichage
	echo($mYFriendIcons['Templates']['Begin']);
	$rep = opendir($mYFriendIcons['Source']['Path']);
	$numcol = 1;
	while ($file = readdir($rep))
		{
		if($file != '..' && $file !='.' && $file !='')
			{
			//Informations sur le chemin du fichier
			$fileinfos = pathinfo($file);
			
			if (is_dir($file) OR empty($fileinfos['extension']) OR (in_array($file,$MYFI_FILES_TO_IGNORE)))
				{
				//Dossier ou fichier  ignorer
				}
			else if (($fileinfos['extension'] == "png") OR ($fileinfos['extension'] == "jpg") OR ($fileinfos['extension'] == "jpeg") OR ($fileinfos['extension'] == "gif"))
				{
				//Nom du fichier sans l'extension
				$fileinfos['filename'] = substr($fileinfos['basename'],0,strlen($fileinfos['basename'])-strlen($fileinfos['extension'])-1);
				//Nom pour affichage
				$fileinfos['displayname'] = mYFI_File_NameToDisplay($fileinfos['filename']);
				//Nom pour fentre PopUp
				$fileinfos['windowname'] = str_replace(array('-','_'), "", $fileinfos['filename']);
				//Dbut de la cellule
				echo($mYFriendIcons['Templates']['ItemBegin']);
				//Recherche de l'aperu ; Jpg, Jpeg, GIF, ou PNG
				$mYFIPreviewTpl = '';
				$fileinfos['previewname'] = $fileinfos['basename'];
				//Code pour l'aperu
				if ($fileinfos['previewname'])
					{
					//Evenement OnClick
					$mYFIThumbailOnClickTpl = str_replace(	array('%window-name%'),
															array($fileinfos['windowname']),
															$mYFriendIcons['Templates']['ThumbailOnClick']);
					//Miniature et aperu
					$mYFIPreviewTpl = str_replace(	array('%thumbail-width%','%thumbail-height%','%no-preview-picture%','%preview-url%','%window-name%','%thumbail-on-click%','%thumbail-url%'),
													array($mYFriendIcons['Thumbails']['Width'],$mYFriendIcons['Thumbails']['Height'],'',$mYFriendIcons['Preview']['URL'].$fileinfos['previewname'],$fileinfos['windowname'],$mYFIThumbailOnClickTpl,$mYFriendIcons['Thumbails']['URL']."/".$fileinfos['previewname']),
													$mYFriendIcons['Templates']['Preview']);
					}
				//Type d'icone
				$mYFIIconTpl = '';
				//Corps de la cellule
				$mYFIItemTpl = str_replace(	array('%preview-tpl%','%download-url%','%download-title%','%display-name%','%icon-tpl%','%yahoo-url%'),
											array($mYFIPreviewTpl,$mYFriendIcons['Settings']['DownloadURL'].$fileinfos['basename'],$mYFriendIcons['Titles']['ClickToDownload'],$fileinfos['displayname'],$mYFIIconTpl,$mYFriendIcons['Settings']['YahooURL'].$fileinfos['basename']),
											$mYFriendIcons['Templates']['ItemBody']);
				echo($mYFIItemTpl);
				//Fin de cellule
				echo($mYFriendIcons['Templates']['ItemEnd']);
				//Test si nouvelle ligne
				if ($numcol == $mYFriendIcons['Settings']['ItemsByGroup'])
					{
					$numcol = 1;
					echo($mYFriendIcons['Templates']['NewItemsGroup']);
					}
				else
					{
					$numcol++;
					}
				}
			}
		}
	closedir($rep);
	clearstatcache();
	echo($mYFriendIcons['Templates']['End']);
	//Fin affichage
	}
	
function mYFI_GetInfos($Mode='html')
	{
	//Configuration de mYFriendIcons
	global $mYFriendIcons;

	if (substr($mYFriendIcons['Source']['Path'], -1) == '/')
		{
		$InfosFile['dirname'] = $mYFriendIcons['Source']['Path'];
		}
	else
		{
		$InfosFile['dirname'] = $mYFriendIcons['Source']['Path'].'/';
		}
	
	if ($mYFriendIcons['Language']=='fr')
		{
		$InfosFile['basename'] = 'info.fr';
		}
	else
		{
		$InfosFile['basename'] = 'info.en';
		}
		
	if ($Mode == 'html')
		{
		$InfosFile['extension'] = 'html';
		}
	else
		{
		$InfosFile['extension'] = 'txt';
		}
	
	if (file_exists($InfosFile['dirname'].$InfosFile['basename'].'.'.$InfosFile['extension']))
		{
		$InfosFileLines = file($InfosFile['dirname'].$InfosFile['basename'].'.'.$InfosFile['extension']);
		}
	else
		{
		$InfosFileLines[0] = '';
		}
		
	$InfosText = '';
	if (count($InfosFileLines) > 1)
		{
		while (list ($key, $val) = each ($InfosFileLines))
			{
			$InfosText .= '<p>'.$val.'</p>';
			}
		}
	else if (count($InfosFileLines) == 1)
		{
		if (strlen($InfosFileLines[0]) > 0)
			{
			$InfosText = '<p>'.$InfosFileLines[0].'</p>';
			}
		else
			{
			$InfosText = '';
			}
		}
	else if (strlen($InfosFileLines) > 0)
		{
		$InfosText = '<p>'.$InfosFileLines.'</p>';
		}
	else
		{
		$InfosText = '';
		}
	
	if ($Mode == 'text')
		{
		$InfosText = strip_tags($InfosText);
		}
		
	return $InfosText;
	}
	
function mYFI_File_NameToDisplay($filename)
	{
	$displayname = str_replace(array('-','_'), " ", $filename);
	$displaynamewords = explode(" ",$displayname);
	foreach ($displaynamewords as $key => $value)
		{
		$displaynamewords[$key] = ucfirst($value);
		}
	$displayname = implode(" ",$displaynamewords);
	
	return $displayname;
	}
?>